static void Wily4Ascii(Screen& s)
{
GenericAsciiMaker(s,
// Walls
-1,'#', 0x48,3, 0x49,3, 0x4A,3,
        0x50,3, 0x51,3, 0x52,3, // block type 1 (middle piece repeatable)
-1,'#', 0x4B,0, 0x4C,0, 0x4D,0,
        0x53,0, 0x54,0, 0x55,0, // block type 2 (middle piece repeatable)
-1,'#', 0x6F,0, // vertical block
-1,'#', 0x4E,3, // inside floor
-1,'#', 0x64,1, 0x65,1,
        0x6C,1, 0x6D,1, // gutsman decoration
// Decorations
-1,' ', 0x17,2, 0x16,3, // inside bg, inside shadow
// Ladder
-1,'|', 0xC5,0,
// Lift
-1,'*', 0x3E,0, // edge
-1,'-', 0x3C,0, // path
-1,'/', 0x3D,0, // hole
// Spike
-1,'^', 0xAE,0, // black bg
// Various backgrounds
-1,'.', 0x00,0, // black background
-1,'1', 0x00,1, // palette 1 (wily room)
-1,'2', 0x00,2, // palette 2 (wily room)
// Teleport
-1,'_', 0x63,1, 0x69,1, // top
-1,'=', 0x68,1, 0x6A,1, // bottom
// Wily room door
-1,'D', 0x06,0,
// Wily room floor
-1,'W', 0x62,0,
-2);
}

#define Wily4Char  DummyChar

static Level Wily4 =
{
	9, // level number
	"Wily4",

	// screens:
	{
		{
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|  #        ##"   "                "
		"##|           ##"   "                "
		"##|    #     ###"   "                "
		"##|           ##"   "                "
		"##        #   ##"   "                "
		"##            ##"   "                "
		"##    ####    ##"   "                "
		"##^^^^####^^^^##"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Up},
		{
		"##|#############"   "                "
		"##|#############"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		"##|           ##"   "                "
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"##          ####"   "                "
		"##          ####"   "         P      "
		"##      GG      "   "                "
		"##      GG      "   "                "
		"##      GG      "   "                "
		"##      GG      "   "                "
		"##      GG      "   "                "
		"##      GG      "   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		"##|#############"   "                "
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"##..##..##..##.."   "       .       ."
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"##..##..##..##.."   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"######..##..####"   "       .   .    "
		"##..##..##..####"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"##..##..##..##.."   "       .       ."
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"##..##..##..##.."   "                "
		"################"   "       v        "
		"################"   "                "
		"################"   "                "
		,Right},
		{
		"###############."   "                "
		"###############."   "                "
		"########       ."   "                "
		"########       ."   "                "
		"########|#######"   "                "
		"########|     ##"   "                "
		"########|     ##"   "                "
		"########|     ##"   "                "
		"..###########|##"   "                "
		"..######     |##"   "                "
		"........     |##"   "                "
		"........     |##"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Right},
		{
		"....############"   "                "
		"....############"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"..............#."   "                "
		"................"   "                "
		"................"   "                "
		"..#.*------/////"   "                "
		"................"   "                "
		"................"   "                "
		"................"   "                "
		"^^^^^^^^^^^^^^^^"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Right},
		{
		"################"   "                "
		"############__##"   "                "
		"..............##"   "                "
		"..............##"   "             O  "
		"...|########==##"   "                "
		"...|........####"   "                "
		"..............##"   "                "
		"..............##"   "                "
		"/---------------"   "                "
		"..............##"   "      U    W    "
		"......#....#..##"   "                "
		"..............##"   "                "
		"^^^^^^^^^^^^^^##"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "X               "
		"..            ##"   "X               "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "X               "
		"..            ##"   "X               "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "X               "
		"..            ##"   "X               "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "                "
		"##            ##"   "        T       "
		"__            ##"   "                "
		"..            ##"   "X               "
		"..            ##"   "X               "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Up},
		{
		"################"   "                "
		"################"   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"##              "   "                "
		"__              "   "                "
		"..              "   "                "
		"..              "   "                "
		"==##############"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Right},
		{
		"################"   "                "
		"################"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              ##"   "                "
		"              DD"   "              SS"
		"              DD"   "              SS"
		"              DD"   "              SS"
		"              DD"   "            P SS"
		"################"   "                "
		"################"   "                "
		"################"   "                "
		"################"   "                "
		,Shutter},
		{
		"................"   "                "
		"................"   "X               "
		"................"   "X               "
		"................"   "X               "
		"........222222.."   "X               "
		"........222222.."   "X               "
		"......11111222.."   "X               "
		"......11111222.."   "X               "
		"......11222222.."   "X               "
		"......11222222.."   "X               "
		"........2222...."   "X               "
		"........2222...."   "X               "
		"WWWWWWWWWWWWWWWW"   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		"WWWWWWWWWWWWWWWW"   "                "
		,End},
	},

	// palette
	{
		15, 32,  0,  2, 
		15, 48, 39, 23, 
		15, 28, 11, 15, 
		15, 32,  0, 60, 

		15, 44, 17, 15, 
		15, 32, 56, 15, 
		15, 48, 42, 15, 
		15, 48, 42, 15, 

		15, 32,  0,  2, 
		15,  0, 32, 16, 
		15, 16, 32, 16, 
		15, 32,  0, 60, 
	},

	// actives
	{
	},

	// enemies
	{
		Enemy( 0, 0x10,0xFF, 0x6 ),
		Enemy( 1, 0x10,0xFF, 0x6 ),
		Enemy( 2, 0x10,0xFF, 0x2C ),
	},

	Wily4Ascii, Wily4Char
};


